> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/backup-and-storage/network-file-storage/api-how-tos/create-cluster.md).

# Create Cluster

To create a Network File Storage cluster through the API, perform a POST request with the name and description of the cluster.

{% hint style="info" %}
**Prerequisites:** Only contract administrators, owners, and users with **accessAndManageNFS** privileges can create and manage clusters.
{% endhint %}

## Endpoints

Use a [<mark style="color:blue;">region-specific endpoint</mark>](/cloud/backup-and-storage/network-file-storage/api-how-tos.md#regional-endpoints) to create a cluster: `https://nfs.{region}.ionos.com/clusters`

## Request

{% hint style="info" %}
**Note:** The following request contains sample values. Remember to replace them with the relevant information.
{% endhint %}

```json
curl -X 'POST' \
  'https://nfs.de-txl.ionos.com/clusters' \
  -H 'accept: application/json' \
  -H 'Content-Type: application/json' \
  -d '{
  "metadata": {},
  "properties": {
    "name": "Cluster 1",
    "connections": [
      {
        "datacenterId": "123e4567-e89b-12d3-a456-426614174001",
        "lan": "1",
        "ipAddress": "10.254.64.1/24"
      }
    ],
    "nfs": {
      "minVersion": "4.2"
    },
    "size": 8
  }
}
```

{% tabs %}
{% tab title="Request Header Parameters" %}
To make authenticated requests to the API, the following fields are mandatory in the request header:

| Header Parameters | Required |  Type  | Description                                                                                                                                         |
| ----------------- | :------: | :----: | --------------------------------------------------------------------------------------------------------------------------------------------------- |
| `Authorization`   |    yes   | string | Use a `Bearer token`. For more information, see [Authentication](/cloud/backup-and-storage/network-file-storage/api-how-tos.md#api-authentication). |
| `Content-Type`    |    yes   | string | Set this to `application/json`.                                                                                                                     |
| {% endtab %}      |          |        |                                                                                                                                                     |

{% tab title="Request Body Parameters" %}
Below is the list of mandatory body parameters:

| Body Parameters | Type   | Description                                                                                                                             | Example                                |
| --------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------- |
| `name`          | string | The human-readable name of your cluster.                                                                                                | `NFS cluster`                          |
| `datacenterId`  | string | The ID of the data center where the NFS cluster is located in.                                                                          | `e69b22a5-8fee-56b1-b6fb-4a07e4205ead` |
| `lan`           | string | The LAN to which the NFS cluster should be connected.                                                                                   | `1`                                    |
| `ipAddress`     | string | The IP address and prefix of the NFS cluster. The IP address can be either IPv4 or IPv6. The IP address must include the CIDR notation. | `10.254.64.1/24`                       |
| {% endtab %}    |        |                                                                                                                                         |                                        |
| {% endtabs %}   |        |                                                                                                                                         |                                        |

## Response

A **201** message confirms that the cluster creation is successful.

```json
{
  "id": "e69b22a5-8fee-56b1-b6fb-4a07e4205ead",
  "type": "cluster",
  "href": "/clusters/e69b22a5-8fee-56b1-b6fb-4a07e4205ead",
  "metadata": {
    "createdDate": "2020-12-10T13:37:50+01:00",
    "createdBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "createdByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedDate": "2020-12-11T13:37:50+01:00",
    "lastModifiedBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "resourceURN": "ionos:<product>:<location>:<contract>:<resource-path>",
    "status": "AVAILABLE",
    "statusMessage": null
  },
  "properties": {
    "name": "Cluster 1",
    "connections": [
      {
        "datacenterId": "123e4567-e89b-12d3-a456-426614174001",
        "lan": "1",
        "ipAddress": "10.254.64.1/24"
      }
    ],
    "nfs": {
      "minVersion": "4.2"
    },
    "size": 8
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/backup-and-storage/network-file-storage/api-how-tos/create-cluster.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
